/****************************************************************************
 *
 *	File Name:		MAIN.C
 *	Description:	Routines to demonstrate the TPS assert code.
 *					The code in this module will trigger a series of
 *					Asserts to show how to use the TPS assert libraries.
 *	Version:		v 1.00
 *	Author:			TPS Engineering Staff
 *	Date:			10/23/96
 *
 *	Copyright (C) 1994-1996 by Turning Point Software, Inc. All Rights Reserved.
 *
 ****************************************************************************
 */

#include <stdio.h>

#include "TPSDEFS.H"
#include "TPSDEBUG.H"

ASSERTNAME

//	function prototypes
int		main(void);
void	AssertTest(void);
void	UnfinishedCode(void);

int main(void)
{
	//	Init the Macintosh Toolbox
	InitGraf( (Ptr)&qd.thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(0L);
	MaxApplZone();
	FlushEvents(everyEvent, 0);

	//	startup the TPS debug library
	tdb_StartupDebugLib(NULL, 0L);
	
	//	call our example assert code
	AssertTest();
	
	//	shutdown the TPS debug library
	tdb_ShutdownDebugLib();
	return TRUE;
}

void	AssertTest(void)
{
	char *lpMem;
	char lpTest[] = "This is a test string";
	char lpBytes[] = {1, 2, 3, 4};

	//	show a basic assert
	lpMem = NULL;
	TpsAssert(NULL != lpMem, "Invalid Null Pointer");
	
	//	show an assert that dumps a byte array
	TpsAssertB((lpBytes[0] + lpBytes[1] + lpBytes[2] + lpBytes[3])
					!= 10, "Bad array sum", lpBytes, sizeof(lpBytes));

	//	show an assert that dumps a string
	TpsAssertS(lpTest[0] != 'T', "Incorrect value in string", lpTest);
	
	//	show asserts for code that's not ready yet
	UnfinishedCode();
}

void	UnfinishedCode(void)
{
	//	show asserts for code that's not ready yet
	UnimplementedCode();
	UntestedCode();
}
