/****************************************************************************
 *
 *	File Name:		STACKCRA.H
 *	Description:	Header file for stack crawl.
 *	Version:		v 1.00
 *	Author:			TPS Engineering Staff
 *	Date:			2/28/95
 *
 *	Copyright (C) 1994-1996 by Turning Point Software, Inc. All Rights Reserved.
 *
 ****************************************************************************
 */

#ifndef _STACKCRA_H_
#define _STACKCRA_H_

// Windows requires packed structures
#if defined(WIN)
#pragma pack(1)
#endif

//	structure of the symbol list
typedef struct tagSYMLIST
{
	uWORD	wItemCnt;				/* # Entries */
	uWORD	padding;				/* RMS - long word (PowerPC) alignment */
	uLONG	byteCount;				/* actual # bytes used in symbols array */
	char	symbols[1];				/* RMS - actually variable length */
} SYMLIST, FAR* LPSYMLIST;

MacCode( typedef LPSYMLIST*	HSYMLIST; )
WinCode( typedef HGLOBAL	HSYMLIST; )

// restore default packing...
#if defined(WIN)
#pragma pack()
#endif

/*
 * Prototypes...
 */
TDBAPI( BOOLEAN ) _tdb_InitStackCrawl( DEBUGPARMS FAR *lpDebugParms, uLONG ulFlags );
TDBAPI( BOOLEAN ) _tdb_DoStackCrawl( VOID );
TDBAPI( VOID )    _tdb_DeinitStackCrawl( VOID );



MacCode( TDBAPI(VOID) _tdb_DisplayStackCrawl(WindowPtr window,Rect* prcDisplay,short sTop); )


WinCode( TDBAPI( BOOLEAN )	_tdb_InitCodeViewSearch( HINSTANCE hModule ); )
WinCode( TDBAPI( VOID )	   _tdb_DeinitCodeViewSearch( VOID ); )
WinCode( TDBAPI( BOOLEAN )	_tdb_FindCodeViewSymbol( HINSTANCE hinst, HFILE fhExe, 
												WORD wSegment, WORD wOffset,
												LPSTR ProcName, WORD cbProcName,
												LPSTR SegmentName, WORD cbSegmentName,
												WORD FAR *pProcOffset
												); )

#endif /* _STACKCRA_H_ */
