// Filename: parser.cpp      This file contains the methods for the parser class.

#include <string.h>
#include <iostream.h>
#include "parser.h"

// Constructor.

Parser::Parser(void)
{
    statement[0] = '\0';
}


// This method will parse the user input, if it is a valid statement, it will
// send it to be parsed further, otherwise it will generate an error.

void Parser::parse_input(void)
{
int done = FALSE;
int in_while = FALSE;
char *p = NULL;
Input the_input;
Instruction *instruct;
Loop *while_loop;
Variable vars;

    // Read each line of input until an END statement is found, parse it, and
    // send it to be parsed further by the particular instruction.
    
    while (!done)
    {
        the_input.read_input(statement);
        if (!strcmp("END", statement))
        {
            done = TRUE;
            vars.show_variables();
        }
        
        // If the ENDWHILE is reached, execute the statements inside the while loop.

        else if (!strcmp("ENDWHILE", statement))
        {
            if (in_while)
            {
                while_loop->execute(vars);
                in_while = FALSE;
                delete while_loop;
            }
        }
        else
        {
            p = strstr(statement, ")");
            if (p)
            {
                p = strtok(statement, "(");
                if (p)
                {
                    if (!strcmp("ASSIGN", p))
                    {
                        instruct = new Assign;
                    }
                    else if (!strcmp("INC", p))
                    {
                        instruct = new Increment;
                    }
                    else if (!strcmp("ADD", p))
                    {
                        instruct = new Add;
                    }
                    else if (!strcmp("SUB", p))
                    {
                        instruct = new Subtract;
                    }
                    else if (!strcmp("COPY", p))
                    {
                        instruct = new Copy;
                    }
                    else if (!strcmp("WHILENE", p))
                    {
                        instruct = new Whilene;
                        while_loop = new Loop;
                        in_while = TRUE;
                    }
                    else
                    {
                        cout << "ERROR: Programming construct not valid";
                        done = TRUE;
                    }

                    if (!done)
                    {
                        done = instruct->check_syntax(vars);
                        if (!done)
                        {
                            // If the statement is inside a while loop, add it to the list.
                            // Otherwise, execute the statement.
                            
                            if (in_while)
                            {
                                while_loop->add_loop(instruct);
                            }
                            else
                            {
                                instruct->execute(vars);
                                delete (instruct);
                            }
                        }
                    }
                }
                else
                {
                    cout << "ERROR: Missing Opening Parenthesis";
                    done = TRUE;
                } // end if(p) - opening parenthesis
            }
            else
            {
                cout << "ERROR: Missing Closing Parenthesis";
                done = TRUE;
            } // end if(p) - closing parenthesis
        }
    } // end while
}



